#include<iostream>

using namespace std;

long suma (int *a,int i,int j)
{
    long x=0;
    for(int k=i; k<j; k++)
        x+=a[k];
    return x;
}

void funkcija(int *a,int k,int i,int j,long &x)
{
    if(k==0)
    {
        x+=suma(a,i,j);
    }
    else
    {
        for(int p=i; p<=j; p++)
        {
            for(int q=p; q<=j; q++)
            {
                funkcija(a,k-1,p,q,x);
            }
        }
    }
    x=x%1000000007;
}

int main()
{
    int n,k;
    long x=0;
    cin>>n>>k;
    int *a=new int[n];
    for(int i=0; i<n; i++)
        cin>>a[i];
    funkcija(a,k,0,n,x);
    cout<<x;
    return 0;
}